=== doc/CMakeLists.txt ===
include(UseDoxygen)
